# UniTAP.dev.modules.dut_tests.dut_default_params.dp_2_1_source_general_tab

class MaxLinkBwPolicy(enum.IntEnum):

Describes available values for maximum link bandwidth policy.

Link1LRBR = <MaxLinkBwPolicy.Link1LRBR: 262>
Link1LHBR = <MaxLinkBwPolicy.Link1LHBR: 266>
Link2LRBR = <MaxLinkBwPolicy.Link2LRBR: 518>
Link2LHBR = <MaxLinkBwPolicy.Link2LHBR: 522>

##### Inherited Members

enum.Enum
  name
  value
builtins.int
  conjugate
  bit_length
  bit_count
  to_bytes
  from_bytes
  as_integer_ratio
  real
  imag
  numerator
  denominator

class TestAutomationFlagsDP21(UniTAP.dev.modules.dut_tests.dut_default_params.dp_1_4_source_general_tab.TestAutomationFlags):

Class `TestAutomationFlagsDP21` allows configuring test automation flags:

- Set and get video operator input flag `video_operator_input`.
- Set and get DSC VIC flag `dsc_vis_val`.

Also has all the `TestAutomationFlags` functionality.

video_operator_input: bool

Set and get video operator input flag. If flag == true -> If Source DUT does not generate the requested format then GUI request will be made to operator to generate the requested format from the EDID (request and waits for test operator input). If flag == false -> If Source DUT does not generate the requested Video Format, then no GUI request will be made, and test will fail if parameters does not match (request and waits for test operator input).

Usually use for manual testing.

###### Returns:

> object of bool type

dsc_vis_val: bool

Set and get DSC visual validation flag. If flag == true -> will check timing, color depth, color space and video CRC. If flag == false -> will check timing, color depth, color space without checking video CRC.

Usually use for manual checking.

###### Returns:

> object of bool type

##### Inherited Members

UniTAP.dev.modules.dut_tests.dut_default_params.dp_1_4_source_general_tab.TestAutomationFlags
  TestAutomationFlags
  test_link_training
  test_edid_read
  test_video_pattern
  test_audio_pattern
  event_indication

class LinkRateDp21(UniTAP.dev.modules.dut_tests.test_group_params_types.Param):

Class `LinkRateDp21` describes support DP 2.1 rates. Allows getting and setting values.

- Support 10 Gbps `support_10Gbps`.
- Support 13.5 Gbps `support_13_5Gbps`.
- Support 20 Gbps `support_20Gbps`.

LinkRateDp21(json_obj)
support_10Gbps: bool

Set and get 10 Gbps flag support.

###### Returns:

> object of bool type

support_20Gbps: bool

Set and get 20 Gbps flag support.

###### Returns:

> object of bool type

support_13_5Gbps: bool

Set and get 13.5 Gbps flag support.

###### Returns:

> object of bool type

##### Inherited Members

UniTAP.dev.modules.dut_tests.test_group_params_types.Param
  clear
  direct_set_def_value
  default_value
  min_value
  max_value
  config_id
  config_id_name
  name
  value_type
  enumeration_variants
  bit_field_list
  data_length

class DutCapsDp21Flags(UniTAP.dev.modules.dut_tests.test_group_params_types.Param):

Class `DutCapsDp21Flags` inherited of class`DutCapsFlags` which defines the DUT capabilities as flags and allows setting:

- Maximum link bandwidth policy supported flag `max_link_bandwidth_policy_supported`.

Also has all the `DutCapsFlags` functionality.

DutCapsDp21Flags(json_obj)
voltage_swing_supported: bool

Set and get Voltage swing level flag support.

###### Returns:

> object of bool type

pre_emphasis_supported: bool

Set and get Pre-emphasis level flag support.

###### Returns:

> object of bool type

fixed_timing_dut_supported: bool

Set and get Fixed timing DUT flag support.

###### Returns:

> object of bool type

spread_spectrum_supported: bool

Set and get Spread Spectrum flag support.

###### Returns:

> object of bool type

change_vf_without_lt_supported: bool

Set and get Video format change without LT flag support.

###### Returns:

> object of bool type

e_ddc_protocol_supported: bool

Set and get E-DDC protocol flag support.

###### Returns:

> object of bool type

audio_transmission_supported: bool

Set and get Audio Info Frame for 2 channel audio transmission flag support.

###### Returns:

> object of bool type

dut_is_type_c_device: bool

Set and get Define that DUT is Type-C device flag support.

###### Returns:

> object of bool type

fec_supported: bool

Set and get FEC flag support.

###### Returns:

> object of bool type

fec_disable_sequence_supported: bool

Set and get FEC disable sequence flag support.

###### Returns:

> object of bool type

audio_without_video_supported: bool

Set and get Audio without Video flag support.

###### Returns:

> object of bool type

dsc_supported: bool

Set and get DSC flag support.

###### Returns:

> object of bool type

dsc_block_prediction_supported: bool

Set and get DSC block prediction flag support.

###### Returns:

> object of bool type

max_link_bandwidth_policy_supported

Set and get Maximum link bandwidth policy flag support.

###### Returns:

> object of bool type

use_3tap_conversion

Set and get 3TAP conversion flag using.

###### Returns:

> object of bool type

usb4_tunnel_presented

Set and get USB4 tunnel presented flag.

###### Returns:

> object of bool type

native_display_id_read: bool

Set and get DUT supports native Display ID read flag support.

###### Returns:

> object of bool type

display_id_vii_supported: bool

Set and get DisplayID Type VII Detailed Timing Descriptor flag support.

###### Returns:

> object of bool type

display_id_viii_supported: bool

Set and get DisplayID Type VIII Detailed Timing Descriptor flag support.

###### Returns:

> object of bool type

display_id_ix_supported: bool

Set and get DisplayID Type IX Detailed Timing Descriptor flag support.

###### Returns:

> object of bool type

display_id_x_supported: bool

Set and get DisplayID Type X Detailed Timing Descriptor flag support.

###### Returns:

> object of bool type

display_id_tiled_display_topology: bool

Set and get 2x1 tiled display and DisplayID Tiled Display Topology data block flag support.

###### Returns:

> object of bool type

display_id_tiled_stereo_display: bool

Set and get Field sequential stereo and DisplayID Tiled Stereo Display Interface data block flag support.

###### Returns:

> object of bool type

stacked_frame_stereo_supported: bool

Set and get Stacked frame stereo and DisplayID Tiled Stereo Display Interface data flag support.

###### Returns:

> object of bool type

dynamic_refresh_rate_support: bool

Set and get Dynamic Refresh Rate with VBlank stretch with MSA_TIMING_PAR_IGNORED flag supported.

###### Returns:

> object of bool type

##### Inherited Members

UniTAP.dev.modules.dut_tests.test_group_params_types.Param
  clear
  direct_set_def_value
  default_value
  min_value
  max_value
  config_id
  config_id_name
  name
  value_type
  enumeration_variants
  bit_field_list
  data_length

class DutCapsDp21:

Class `DutCapsDp21` defines the DUT capabilities and allows setting:

- Defines the maximum number of lanes supported by the DUT `max_lanes`.
- Maximum link rate supported by the DUT `max_link_rate`.
- Dut capabilities flags `dut_caps_flags` type `DutCapsFlags`.

DutCapsDp21(json_obj)
max_lanes: int

Set and get number of maximum lanes.

###### Returns:

> object of int type

max_link_rate

Set and get number of maximum link rate.

###### Returns:

> object of int type

dut_caps_flags: DutCapsDp21Flags

Set and get DUT capabilities flags.

###### Returns:

> object of `DutCapsFlags` type

class DebugOptions:
DebugOptions(json_obj)
continue_on_fail: bool

Set and get continue on fail flag.

###### Returns:

> object of bool type

force_visual_check: bool

Set and get Force manual visual check flag.

###### Returns:

> object of bool type

class GeneralSourceDUTDp21SettingTab:

Class `GeneralSourceDUTDp21SettingTab` inherited of class`GeneralSourceDUTDp14SettingTab` allows working with parameters from General source part.

- Set and get timeout `timeout`.
- Set and get `hpd_pulse_duration`. Describes duration of long HPD pulses generated, in milliseconds.
- Set and get DUT capabilities `dut_caps` type `DutCapsDp21`.
- Set and get DUT link rates `dut_link_rates` type `LinkRateDp21`.
- Set and get LTTPR device count `lttpr_device_count`.
- Set and get maximum link bandwidth policy `max_link_bw_policy` type `MaxLinkBwPolicy`.
- Set and get DSC maximum slice number `dsc_max_slice`.
- Set and get DSC version `dsc_version`.
- Set and get debug options `debug_options` type `DebugOptions`

GeneralSourceDUTDp21SettingTab(json_obj)
timeout: int

Set and get test timeout, in milliseconds.

###### Returns:

> object of int type

dut_caps: DutCapsDp21

Set and get DUT caps.

###### Returns:

> object DutCapsDp21

hpd_pulse_duration: int

Set and get HPD pulse duration.

###### Returns:

> object of int type

test_automation: TestAutomationFlagsDP21

Set and get test automation flags.

###### Returns:

> object TestAutomationFlags

dut_link_rates: LinkRateDp21

Set and get DUT link rates.

###### Returns:

> object LinkRateDp21

max_link_bw_policy: int

Set and get maximum link bandwidth policy.

###### Returns:

> object int

lttpr_device_count: int

Set and get LTTPR device count.

###### Returns:

> object int

dsc_max_slice: int

Set and get DSC maximum slice number.

###### Returns:

> object of int type

dsc_version: list

Set and get DSC version. Setter: .dsc_version((1, 2))

###### Returns:

> object of list type

debug_options: DebugOptions

Set and get debug options.

###### Returns:

> object of 'DebugOptions' type